@if exp="typeof(global.saveLabelManager) == 'undefined'"
@iscript
//
//@Z[u\xEǃXLbvǗvOC
//
class SaveLabelManagerPlugin extends KAGPlugin
{
	var win;
	var sv, gv;
	var sID, iID;
	var noChk;
	var f_incRecordLabel;
	var f_getCurrentRead;
	var f_onConductorLabel;
	var f_onConductorJump;
	var f_onConductorCall;
	var f_onConductorReturn;
	var f_onConductorAfterReturn;

	function SaveLabelManagerPlugin(win, sv, gv)
	{
		super.KAGPlugin();

		this.win = win;
		this.sv = sv;
		this.gv = gv;

		sID = "";
		iID = 0;
		noChk = true;

		readFlags = new Dictionary() if readFlags === void;
		skipIfRead = true if skipIfRead === void;

		sStack = new Array() if sStack === void;
		sStack.count = 2;
		iStack = new Array() if iStack === void;
		iStack.count = 2;

		with(win)
		{
			f_incRecordLabel = .incRecordLabel;
			f_getCurrentRead = .getCurrentRead;
			f_onConductorLabel = .onConductorLabel;
			f_onConductorJump = .onConductorJump;
			f_onConductorCall = .onConductorCall;
			f_onConductorReturn = .onConductorReturn;
			f_onConductorAfterReturn = .onConductorAfterReturn;

			.incRecordLabel = incRecordLabel;
			.getCurrentRead = getCurrentRead;
			.onConductorLabel = onConductorLabel;
			.onConductorJump = onConductorJump;
			.onConductorCall = onConductorCall;
			.onConductorReturn = onConductorReturn;
			.onConductorAfterReturn = onConductorAfterReturn;
		}
	}

	function finalize()
	{
		with(win)
		{
			.onConductorAfterReturn = f_onConductorAfterReturn;
			.onConductorReturn = f_onConductorReturn;
			.onConductorCall = f_onConductorCall;
			.onConductorJump = f_onConductorJump;
			.onConductorLabel = f_onConductorLabel;
			.getCurrentRead = f_getCurrentRead;
			.incRecordLabel = f_incRecordLabel;
		}

		super.finalize();
	}

	function isRead()
	{
		if(!skipIfRead || noChk) return true;
		if(sID == "" || readFlags[sID] === void) return false;

		var flags = readFlags[sID][iID >> 6];
		if(flags === void) return false;

		return (flags & (1 << (iID & 63))) != 0;
	}

	function setReadFlagName(name, index = 0)
	{
		if(win.usingExtraConductor) return;

		sID = name;
		iID = index;
	}

	function setReadFlag()
	{
		if(win.usingExtraConductor) return;

		var flags = readFlags[sID];

		flags = readFlags[sID] = new Array() if flags === void;

		var index = iID >> 6;
		flags[index] = 0 if flags[index] === void;
		flags[index] |= (1 << (iID++ & 63));
	}


	function incRecordLabel(count)
	{
		f_incRecordLabel(false);
	}

	function getCurrentRead()
	{
		return isRead() || !win.autoRecordPageShowing;
	}

	function onConductorLabel(label, page)
	{
		var ret = f_onConductorLabel(...);

		setReadFlagName(win.conductor.curStorage + "|" + label);

		return ret;
	}

	function onConductorJump(elm)
	{
		var ret = f_onConductorJump(...);

		if(elm.target == "")
			setReadFlagName((elm.storage != "" ? elm.storage : win.conductor.curStorage) + "|");

		return ret;
	}

	function onConductorCall(elm)
	{
		var ret = f_onConductorCall(...);

		sStack[sStack.count-1] = sID;
		iStack[iStack.count-1] = iID;
		sStack.count++;
		iStack.count++;

		if(elm.target == "")
			setReadFlagName((elm.storage != "" ? elm.storage : win.conductor.curStorage) + "|");

		return ret;
	}

	function onConductorReturn(elm)
	{
		var ret = f_onConductorReturn(...);

		sStack.count--;
		iStack.count--;

		if(elm.storage != "" || elm.target != "")
			setReadFlagName((elm.storage != "" ? elm.storage : win.conductor.curStorage) + "|" + elm.target);
		else
			setReadFlagName(sStack[sStack.count-1], iStack[iStack.count-1]);

		return ret;
	}

	function onConductorAfterReturn()
	{
		f_onConductorAfterReturn(...);

		if(sID === void)
			setReadFlagName(win.conductor.curStorage + "|");
	}

	property skipIfRead
	{
		setter(x){ sv.skipIfRead = x; }
		getter() { return sv.skipIfRead; }
	}

	// Ǐ sf.readFlags ƂÕVXeϐɋL^܂B
	// ʏ͕ύXKv͂܂񂪁Aʂ̖ÕVXeϐɋL^ꍇ́A
	// sv.readFlags ̕isetter  getter ꂼjĂB
	// Fsf.kidoku ƂOŋL^ꍇ sv.readFlags  sv.kidoku ƕύXĂB
	property readFlags
	{
		setter(x){ sv.readFlags = x; }
		getter() { return sv.readFlags; }
	}

	// ǏL^邽߂ɎgpϐƂ f.stSID  f.stIID ƂO̕ϐQ[ϐɋL^܂B
	// ʏ͕ύXKv͂܂񂪁Aʂ̖ÕQ[ϐɋL^ꍇ́A
	// gv.stSID  gv.stIID  stSID, stIID ̕Ǐ̏ꍇƓ悤ɕύXĂB
	property sStack
	{
		setter(x){ gv.stSID = x; }
		getter() { return gv.stSID; }
	}

	property iStack
	{
		setter(x){ gv.stIID = x; }
		getter() { return gv.stIID; }
	}
}

kag.addPlugin(global.saveLabelManager = new SaveLabelManagerPlugin(kag, sf, f));

@endscript


; label }N
;
; label }NLqZ[uƁA[h̏ꏊĊJł܂B
; ܂Alabel }N̒Oɂ郁bZ[ẂAǃ`FbN̑ΏۂƂȂ܂B
@macro name=label
@eval exp="saveLabelManager.noChk = false"
@call storage="SaveLabelManager.ks" target=*l
@eval exp="saveLabelManager.setReadFlag(), saveLabelManager.noChk = true"
@endmacro


; skipopt }N
;
; @skipopt kidoku=false (܂ [skipopt kidoku=false]) ƋLqƁA
; ȍ~ F L[ȂǂŃXLbvAǕXLbv܂B
;
; @skipopt kidoku=true (܂ [skipopt kidoku=true]) ƋLqƁA
; ȍ~͊Ǖ̂݃XLbv܂B
;
; ftHgł́AǕ̂݃XLbv(kidoku=true)ɂȂĂ܂B
@macro name=skipopt
@eval exp="saveLabelManager.skipIfRead = +mp.kidoku"
@endmacro

@endif
@return


*l|
@return
